(function() {
    'use strict';

    angular.module('asdApp', ['ngRoute'])
        .config(['$routeProvider', 'VEEVA_MESSAGES', AppConfig]);

    function AppConfig($routeProvider, VEEVA_MESSAGES) {

        $routeProvider
            .when('/dashboard', {
                templateUrl: 'views/account-sales-dashboard.html',
                controller: 'AccountSalesDashboardCtrl',
                controllerAs: 'dash',
                resolve: {
                    currentAccount: ['$q', 'userService', 'accountService', 'messageService',
                        function($q, userService, accountService, messageService) {
                        var deferred = $q.defer();

                        userService.getCurrentUser().then(function(currentUser) {
                            var defaultLanguageLocale = 'en_US';
                            var languageLocale = currentUser.LanguageLocaleKey || defaultLanguageLocale;

                            messageService.getTranslations(_.values(VEEVA_MESSAGES), languageLocale).then(function(translations) {
                                if(_.values(translations).length === 0) {
                                    messageService.getTranslations(_.values(VEEVA_MESSAGES), defaultLanguageLocale).then(function() {
                                        getAccount();
                                    });
                                } else {
                                    getAccount();
                                }
                            });

                            function getAccount() {
                                accountService.getCurrentAccount().then(function(currentAccount) {
                                    accountService.getAccount(currentAccount.Id).then(function(account) {
                                        deferred.resolve(account);
                                    });
                                });
                            }
                        });

                        return deferred.promise;
                    }]
                }
            })
        ;
    }
})();