(function() {
    'use strict';

    angular.module('asdApp')
        .directive('reportTable', directiveFn);

    function directiveFn() {
        var controller = ['$scope', function($scope) {

            $scope.checkAvailableTrendingPercentage = function(data, property) {
                if(data.trendingPercentage && data.trendingPercentage[property]) {
                    return true;
                } else {
                    return false;
                }
            };

            $scope.checkAvailableSupplementaryData = function(data, property) {
                if(data.supplementaryData && angular.isDefined(data.supplementaryData[property])) {
                    return true;
                } else {
                    return false;
                }
            };

            $scope.checkAvailableFootnoteData = function(data, property) {
                if(data.footnoteData && typeof data.footnoteData[property] === 'string' && data.footnoteData[property].length > 0) {
                    return true;
                } else {
                    return false;
                }
            };

            $scope.isTrendingUp = function(value) {
                if(value > 0) {
                    return true;
                } else {
                    return false;
                }
            };
        }];

        return {
            restrict: 'E',
            templateUrl: 'views/report-table.html',
            scope: {
                headers: '=',
                data: '='
            },
            controller: controller
        };
    }
})();