(function() {
    'use strict';

    angular.module('asdApp')
        .factory('accountService', ['$q', 'endpoints', factoryFn])
    ;

    function factoryFn($q, endpoints) {
        var accountService = this;
        var currentAccount;
        var account;

        accountService.getCurrentAccount = function() {
            var deferred = $q.defer();

            if(angular.isDefined(currentAccount)) {
                deferred.resolve(currentAccount);

            } else {
                endpoints.fetchCurrentAccount().then(function(resp) {
                    console.log(resp);
                    currentAccount = resp;
                    deferred.resolve(currentAccount);
                });
            }

            return deferred.promise;
        };

        accountService.getAccount = function(accountId) {
            var deferred = $q.defer();

            if(angular.isDefined(account)) {
                deferred.resolve(account);

            } else {
                endpoints.fetchAccount(accountId).then(function(resp) {
                    console.log(resp);
                    account = resp.Account[0];
                    deferred.resolve(account);
                });
            }

            return deferred.promise;
        };

        return accountService;
    }
})();