(function() {
    'use strict';

    angular.module('asdApp')
        .factory('chartDataManager', [factoryFn])
    ;

    function factoryFn() {
        var manager = this;
        var chartLabels = [];
        var myProductSalesData = [];
        var competitorProductSalesData = [];
        var profileProductsSalesData = [];
        var profileMarketSalesData = [];
        var callActivityData = [];
        var emailActivityData = [];

        manager.setChartLabels = function(labels) {
            chartLabels = labels;
        };

        manager.setMyProductSalesChartData = function(datasets) {
            myProductSalesData = datasets;
        };

        manager.setCompetitorProductSalesChartData = function(datasets) {
            competitorProductSalesData = datasets;
        };

        manager.setCallActivityChartData = function(datasets) {
            callActivityData = datasets;
        };

        manager.setProfileProductChartData = function(datasets) {
            profileProductsSalesData = datasets;
        };

        manager.setProfileMarketChartData = function(datasets) {
            profileMarketSalesData = datasets;
        };

        manager.setEmailActivityChartData = function(datasets) {
            emailActivityData = datasets;
        };

        manager.getChartLabels = function() {
            return chartLabels || [];
        };

        manager.getMyProductSalesChartData = function() {
            return myProductSalesData || [];
        };

        manager.getCompetitorProductSalesChartData = function() {
            return competitorProductSalesData || [];
        };

        manager.getProfileProductChartData = function() {
            return profileProductsSalesData || [];
        };

        manager.getProfileMarketChartData = function() {
            return profileMarketSalesData || [];
        };

        manager.getCallActivityChartData = function() {
            return callActivityData || [];
        };

        manager.getEmailActivityChartData = function() {
            return emailActivityData || [];
        };

        manager.clearChartData = function() {
            chartLabels = [];
            myProductSalesData = [];
            competitorProductSalesData = [];
            profileProductsSalesData = [];
            profileMarketSalesData = [];
            callActivityData = [];
            emailActivityData = [];
        };

        return manager;
    }
})();