(function() {
    'use strict';

    angular.module('asdApp')
        .factory('dataMapTemplateService', ['$q', 'endpoints', factoryFn])
    ;

    function factoryFn($q, endpoints) {
        var dataMapTemplateService = this;
        var dataMapTemplate;

        dataMapTemplateService.getDataMapTemplates = function() {
            var deferred = $q.defer();

            if(angular.isDefined(dataMapTemplate)) {
                deferred.resolve(dataMapTemplate);

            } else {
                endpoints.fetchDataMapTemplates().then(function(resp) {
                    console.log(resp);
                    dataMapTemplate = resp.Data_Map_Template_vod__c;
                    deferred.resolve(dataMapTemplate);
                });
            }

            return deferred.promise;
        };

        return dataMapTemplateService;
    }
})();