(function() {
    'use strict';

    angular.module('asdApp')
        .factory('userService', ['$q', 'endpoints', 'Utilities', factoryFn])
    ;

    function factoryFn($q, endpoints, utilities) {
        var userService = this;
        var currentUser;

        userService.getCurrentUser = function() {
            var deferred = $q.defer();

            if(angular.isDefined(currentUser)) {
                deferred.resolve(currentUser);

            } else {
                endpoints.fetchCurrentUser().then(function(resp) {
                    console.log(resp);
                    currentUser = resp.User[0];
                    deferred.resolve(currentUser);
                });
            }

            return deferred.promise;
        };

        userService.getUserLocale = function() {
            if(angular.isDefined(currentUser) && utilities.isNotEmptyString(currentUser.LocaleSidKey)) {
                return currentUser.LocaleSidKey;
            }
            return 'en';
        };

        userService.getUserTimezone = function() {
            if(angular.isDefined(currentUser) && utilities.isNotEmptyString(currentUser.TimeZoneSidKey)) {
                return currentUser.TimeZoneSidKey;
            }
            return 'GMT';
        };

        return userService;
    }
})();